﻿#include <cuda.h>
#include <device_launch_parameters.h>
#include <cuda_runtime_api.h>

/*__global__ void addKernel(int* c, const int* a, const int* b)
{
    int i = threadIdx.x;
    c[i] = a[i] + b[i];
}*/

extern "C"
{/*
    // Helper function for using CUDA to add vectors in parallel.
    void CUDA_Add(int* c, int* a, int* b, unsigned int size)
    {
        // Launch a kernel on the GPU with one thread for each element.
        addKernel <<<1, size >>> (c, a, b);

    }*/

    int CUDA_SetDevice(int device)
    {
        cudaError_t cudaStatus;
        cudaStatus = cudaSetDevice(device);

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }
    /*
    int CUDA_Malloc(void** allocatedMemory, size_t numberOfBytes)
    {
        cudaError_t cudaStatus;
        cudaStatus = cudaMalloc(allocatedMemory, numberOfBytes);

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }

    int CUDA_MemcpyToDevice(void* deviceData, void* hostData, size_t numberOfBytes)
    {
        cudaError_t cudaStatus;

        cudaStatus = cudaMemcpy(deviceData, hostData, numberOfBytes, cudaMemcpyHostToDevice);

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }

    int CUDA_MemcpyToHost(void* deviceData, void* hostData, size_t numberOfBytes)
    {
        cudaError_t cudaStatus;

        cudaStatus = cudaMemcpy(deviceData, hostData, numberOfBytes, cudaMemcpyDeviceToHost);

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }

    int CUDA_ThreadSynchronize()
    {
        cudaError_t cudaStatus;

        cudaStatus = cudaThreadSynchronize();

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }

    //Sixth: Free device memory
    int CUDA_FreeMemory(void* deviceData)
    {
        cudaError_t cudaStatus;

        cudaStatus = cudaFree(deviceData);

        if (cudaStatus == cudaSuccess)
            return 0;
        else
            return -1;
    }*/
}